#include <windows.h>
#include <scrnsave.h>
#include "resource.h"
#include "Draw.h"

#pragma comment(lib,"scrnsave.lib")
#pragma comment(lib,"d3d8.lib")
#pragma comment(lib,"d3dx8.lib")

BOOL WINAPI RegisterDialogClasses (HANDLE hInst)
{
	return TRUE;
}

BOOL WINAPI ScreenSaverConfigureDialog (HWND hDlg,UINT uMsg, WPARAM wParam,LPARAM lParam)
{
	switch (uMsg) {
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDOK:
			EndDialog(hDlg,TRUE);
			return TRUE;

		case IDCANCEL:
			EndDialog(hDlg,FALSE);
			return TRUE;
		}
		return FALSE;

	case WM_CLOSE:
		EndDialog (hDlg, 0);
		return TRUE;
	}
	return FALSE;
}

LONG WINAPI ScreenSaverProc (HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:    // 
		if(FAILED(InitD3D(hWnd))){
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			return 0;
		}
		SetTimer(hWnd, 1, 50, NULL);
		return 0;

	case WM_TIMER:	   // ^C}[Cxg
		Draw_Main();
		return 0;

	case WM_CLOSE:	   // 
		KillTimer(hWnd, 1);
		DestroyWindow(hWnd);
		Term();
		PostQuitMessage(0);
		return 0;
	}

	return DefScreenSaverProc (hWnd, uMsg, wParam,lParam);
}
