#include <time.h>
#include <malloc.h>

#define WDH 		55	// @iKj
#define HGT 		55	// iKj
#define RELEASE3(p)	if (p){free(p);p=NULL;}

BYTE	Map[HGT][WDH];
int 	dx[4] = {-1, 0, 1, 0};
int 	dy[4] = { 0,-1, 0, 1};

void	Labyrinth();
void	Labyrinth_Sub(int x, int y);
void	Root(int x, int y);
int		RandTo(int max);

// H쐬
void Labyrinth()
{
	int 	x,y,x2,y2,x3,y3,x4,y4,r,i;
	bool	flag,flag2;
	
	srand( (unsigned)time( NULL ) );
	
	// }bv̏ilǂň͂܂ꂽZ(WDH/2)*(HGT/2)j
	for(y=0;y<HGT;y++){
		for(x=0;x<WDH;x++){
			if(x % 2 && y % 2)
				Map[y][x] = 0;
			else
				Map[y][x] = 1;
		}
	}
	
	// 4̗̐Xg
	int rnd_list[24][4] = { {0,1,2,3},{0,1,3,2},{0,2,1,3},{0,2,3,1},
							{0,3,1,2},{0,3,2,1},{1,0,2,3},{1,0,3,2},
							{1,2,0,3},{1,2,3,0},{1,3,0,2},{1,3,2,0},
							{2,0,1,3},{2,0,3,1},{2,1,0,3},{2,1,3,0},
							{2,3,0,1},{2,3,1,0},{3,0,1,2},{3,0,2,1},
							{3,1,0,2},{3,1,2,0},{3,2,0,1},{3,2,1,0} };
	
	for(y=1;y<HGT;y+=2){
		for(x=1;x<WDH;x+=2){
			x4 = x;
			y4 = y;
			flag2 = 0;	// eʘH̍ŏ̕ǉ󂵃tO
			flag = 1;	// ܏HtO
			// 0 ̃ZA珇ɕǂ󂵂đ܏H܂ŒʘHB
			// ʉ߂ŹA2 ɒu
			while(flag && !Map[y4][x4]){
				flag = 0;
				r = RandTo(24);
				for(i=0;i<4;i++){
					x2 = x4 + dx[rnd_list[r][i]];
					y2 = y4 + dy[rnd_list[r][i]];
					if(Map[y2][x2]	&& x2 > 0 && x2 < WDH-1
									&& y2 > 0 && y2 < HGT-1)
					{
						x3 = x4 + dx[rnd_list[r][i]] * 2;
						y3 = y4 + dy[rnd_list[r][i]] * 2;
						if(!Map[y3][x3]){
							Map[y2][x2] = 0;
							Map[y4][x4] = 2;
							// eʘH̍ŏ̃Z̍̕ǂ
							if(!flag2 && (x4 != 1 || y4 != 1)){
								Labyrinth_Sub(x4, y4);
								flag2 = 1;
							}
							x4 = x3;
							y4 = y3;
							flag = 1;
							break;
						}
					}
				}
				// lǂɈ͂܂ĂZ͕ǂ󂵑Ȃ̂łŉ
				if(!flag && !flag2	&& Map[y4-1][x4] && Map[y4][x4-1]
									&& Map[y4+1][x4] && Map[y4][x4+1])
				{
					Labyrinth_Sub(x4, y4);
					flag2 = 1;
				}
			}
		}
	}
	// ǈȊO0ɂ
	for(y=1;y<HGT;y+=2){
		for(x=1;x<WDH;x+=2){
			if(Map[y][x] == 2)
				Map[y][x] = 0;
		}
	}
	Root(1, 1);
	// ƉE̕ǂ
	Map[0][1] = 2;
	Map[HGT-2][WDH-1] = 2;
}// Labyrinth

// ǂ󂵂āA2̒ʘHȂ
void Labyrinth_Sub(int x, int y)
{
	if(x == 1){
		Map[y-1][x] = 0;
	}
	else if(y == 1){
		Map[y][x-1] = 0;
	}
	else{
		int r = RandTo(2);
		Map[y+dy[r]][x+dx[r]] = 0;
	}
}// Labyrinth_Sub

// S[܂ł̃[g߂
void Root(int x, int y)
{
	POINT	*stack; 	// ێX^bN
	int 	num = 0;	// X^bŇ݂̈ʒu
	int 	i,x2,y2,idx,ct;
	size_t	size;
	
	stack = (LPPOINT) malloc(256*sizeof(POINT));	// X^bÑmۂ
	
	while(num >= 0){	// X^bNɂȂI
		ct = 1;
		while(ct){
			Map[y][x] = 2;			// ʂ 2 
			ct = 0;
			for(i=0;i<4;i++){
				x2 = x + dx[i];
				y2 = y + dy[i];
				if(!Map[y2][x2]){	// _͍Ō̒ʘH玎
					idx = i;
					ct ++;
				}
			}
			if(x == WDH-2 && y == HGT-2){	// S[ɒI
				goto End;
			}
			if(ct > 1){ 	// _̍WX^bNɓ
				stack[num].x = x;
				stack[num].y = y;
				num ++;
				// X^bNTCYȂȂǉ
				size = _msize(stack);
				if(sizeof(stack) >= size){
					stack = (POINT*)realloc(stack, size+64*sizeof(POINT));
					if(stack){
						return;
					}
				}
			}
			if(ct > 0){ 		// ʘHɐi
				x += dx[idx];
				y += dy[idx];
			}
		}
		num --;
		if(num >= 0){
			// s~܂肾ƂA_܂ŏ
			while(x != stack[num].x || y != stack[num].y){
				for(i=0;i<4;i++){
					x2 = x + dx[i];
					y2 = y + dy[i];
					if(Map[y2][x2] == 2){
						Map[y][x] = 3;
						x = x2;
						y = y2;
						break;
					}
				}
			}
			x = stack[num].x;	// _̎̒ʘH
			y = stack[num].y;
		}
	}
	
End:RELEASE3(stack);	// IɃX^bÑ
	
	// s~܂肾ʘH
	for(y=1;y<HGT-1;y++){
		for(x=1;x<WDH-1;x++){
			if(Map[y][x] == 3)
				Map[y][x] = 0;
		}
	}
}// Root

// 0 ` max-1 ܂ł̗Ԃ
int RandTo(int max)
{
	return (int)((float)max * rand() / (RAND_MAX + 1.0f));
}
